var CONST_OK = 0;
var CONST_NG = 1;

(function() {
    "use strict";

    //店舗・予約日付・予約時刻・担当者を入れ替えて更新
    function swapYoyaku(appID, inRecNo, inRev, resShop, resDate, resTime, resPerson) {

        var ret = CONST_NG;
        var token = kintone.getRequestToken();
        var appUrl = kintone.api.url('/k/v1/record');
        var strJSON = '{"app": ' + appID + ', "id": ' + inRecNo + ', "revision": ' + inRev +
            ', "record": {"店舗": {"value": "' + resShop + '"}' +
            ', "予約日付": {"value": "' + resDate + '"}' +
            ', "予約時刻": {"value": "' + resTime + '"}' +
            ', "担当者": {"value": "' + resPerson + '"}' +
            ', "キャンセル": {"value": ["C"]}' +
            '}, "__REQUEST_TOKEN__": "' + token + '"}';
        var	xmlhttp = new XMLHttpRequest();
        xmlhttp.open("PUT", appUrl, false);
        xmlhttp.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
        xmlhttp.setRequestHeader('Content-Type', 'application/json');
        xmlhttp.send(strJSON);
        if ((xmlhttp.readyState == 4) && (xmlhttp.status == 200)) {
            ret = CONST_OK;
        } else {
            alert(xmlhttp.status);
            alert(xmlhttp.responseText);
            ret = CONST_NG;
        }
        return ret;
    }

    var frmShop;	// 編集前の店舗
    var frmDate;	// 編集前の予約日付
    var frmTime;	// 編集前の予約時刻
    var frmPerson;	// 編集前の担当者

    //レコード一覧画面のインライン編集またはレコード編集画面が表示された時
    kintone.events.on(['app.record.index.edit.show', 'app.record.edit.show'], function(event) {
        //編集前の店舗、予約日付、予約時刻、担当者を保存しておく
        var record = event.record;
        frmShop = record['店舗']['value'];
        frmDate = record['予約日付']['value'];
        frmTime = record['予約時刻']['value'];
        frmPerson = record['担当者']['value'];

        if (record['予約不可']['value'][0] == "不可" || record['キャンセル']['value'][0] == "C") {
            //予約不可またはキャンセル済の場合は入力不可
            record['お客様番号']['disabled'] = true;
            record['お名前カナ']['disabled'] = true;
            record['お名前漢字']['disabled'] = true;
            record['電話番号']['disabled'] = true;
        }
        return event;
    });

    //各フィールドの値が変更された時
    kintone.events.on(['app.record.index.edit.change.予約不可',
        'app.record.index.edit.change.キャンセル',
        'app.record.edit.change.予約不可',
        'app.record.edit.change.キャンセル'], function(event) {

        var record = event.record;
        if (record['予約不可']['value'][0] == "不可") {
            record['キャンセル']['value'] = ["C"];
        }
        if (record['キャンセル']['value'][0] == "C") {
            //予約不可またはキャンセルの場合は入力不可
            record['お客様番号']['value'] = "";
            record['お客様番号']['disabled'] = true;
            record['お名前カナ']['value'] = "";
            record['お名前カナ']['disabled'] = true;
            record['お名前漢字']['value'] = "";
            record['お名前漢字']['disabled'] = true;
            record['電話番号']['value'] = "";
            record['電話番号']['disabled'] = true;
        } else {
            record['お客様番号']['disabled'] = false;
            record['お名前カナ']['disabled'] = false;
            record['お名前漢字']['disabled'] = false;
            record['電話番号']['disabled'] = false;
        }
        return event;
    });

    //保存ボタンが押された時
    kintone.events.on(['app.record.index.edit.submit', 'app.record.edit.submit'], function(event) {
        var record = event.record;
        var appID = kintone.app.getId();

        //現在の店舗、予約日付、予約時刻、担当者を取り出す
        var newShop = record['店舗']['value'];
        var newDate = record['予約日付']['value'];
        var newTime = record['予約時刻']['value'];
        var newPerson = record['担当者']['value'];
        var ret = CONST_OK;

        if (newShop == frmShop && newDate == frmDate && newTime == frmTime && newPerson == frmPerson) {
            //店舗、予約日付、予約時刻、担当者に変更無し
            return event;
        }
        //店舗、予約日付、予約時刻、担当者の1つ以上が変更された場合
        if (window.confirm('予約の店舗・日時を変更しますか？')) {
            //変更希望の店舗・日時・担当者が空いているかを検索する
            var queryStr = '店舗 = "' + newShop + '" and 予約日付 = "' +
            newDate + '" and 予約時刻 = "' + newTime + '" and 担当者 = "' +
            newPerson + '" and 予約不可 not in ("不可") and お名前カナ = ""';
            var appUrl = kintone.api.url('/k/v1/records') + '?app=' + appID + '&query=' + encodeURI(queryStr);
            var xmlHttp = new XMLHttpRequest();
            xmlHttp.open("GET", appUrl, false);
            xmlHttp.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
            xmlHttp.send(null);

            if ((xmlHttp.readyState == 4) && (xmlHttp.status == 200)) {
                //正常実行
                if (window.JSON) {
                    var obj = JSON.parse(xmlHttp.responseText);
                    if (obj.records[0] != null) {
                        //店舗・予約日付・予約時刻・担当者を入れ替えて更新
                        try {
                            ret = swapYoyaku(appID, obj.records[0]['$id']['value'], obj.records[0]['$revision']['value'], frmShop, frmDate, frmTime, frmPerson);
                            if (ret == CONST_NG) {
                                //エラー
                                event.error = "予約の変更に失敗しました。";
                            }
                        } catch(e) {
                            console.log(e);
                        }
                    } else {
                        //変更希望の店舗・日時・担当者に空き無し
                        event.error = "入力された店舗・日時・担当者に変更できません。";
                        ret = CONST_NG;
                    }
                }
            } else {
                ret = CONST_NG;
            }
        } else {
            ret = CONST_NG;
        }
        if (ret == CONST_NG) {
            //編集前に戻す
            event.error = "予約の変更ができません。変更を中止しました。";
            record['店舗']['value'] = frmShop;
            record['予約日付']['value'] = frmDate;
            record['予約時刻']['value'] = frmTime;
            record['担当者']['value'] = frmPerson;
        }
        return event;
    });
})();

